<?php

// @codingStandardsIgnoreStart
class ControllerExtensionModuleRoistat extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('extension/module/roistat');
        $this->load->model('setting/setting');
        $this->document->setTitle($this->language->get('heading_title'));

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('module_roistat', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
        }

        $data['error_warning'] = isset($this->error['warning']) ? $this->error['warning'] : '';

        $data['text_edit']     = $this->language->get('text_edit');
        $data['text_enabled']  = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');

        $data['button_save']   = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['header']        = $this->load->controller('common/header');
        $data['column_left']   = $this->load->controller('common/column_left');
        $data['footer']        = $this->load->controller('common/footer');

        $data['entry_username']   = $this->language->get('entry_username');
        $data['entry_password']   = $this->language->get('entry_password');

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
        );

        if (!isset($this->request->get['module_id'])) {
            $data['breadcrumbs'][] = array(
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/module/roistat', 'user_token=' . $this->session->data['user_token'], true)
            );
        } else {
            $data['breadcrumbs'][] = array(
                'text' => $this->language->get('heading_title'),
                'href' => $this->url->link('extension/module/roistat', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true)
            );
        }

        $data['action'] = $this->url->link('extension/module/roistat', 'user_token=' . $this->session->data['user_token'], true);
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

        $data['user_token']  = $this->session->data['user_token'];
        $data['header']      = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer']      = $this->load->controller('common/footer');

        $settings = $this->model_setting_setting->getSetting('module_roistat');

        $data['username'] = array_key_exists('module_roistat_username', $settings) ? $settings['module_roistat_username'] : '';
        $data['password'] = array_key_exists('module_roistat_password', $settings) ? $settings['module_roistat_password'] : '';

        $this->response->setOutput($this->load->view('extension/module/roistat', $data));
    }

    public function install() {
        $this->load->model('setting/setting');
        $this->db->query("ALTER TABLE `" . DB_PREFIX . "order` ADD `roistat_visit` varchar(120) COLLATE 'utf8_general_ci' NOT NULL DEFAULT '', COMMENT='';");
    }

    public function validate() {
        if (!$this->user->hasPermission('modify', 'extension/module/roistat')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        return !$this->error;
    }

    public function uninstall() {
        $this->load->model('setting/setting');
        $this->db->query("ALTER TABLE `" . DB_PREFIX . "order` DROP COLUMN `roistat_visit`;");
        $this->model_setting_setting->deleteSetting('module_roistat');
    }
}